/* Copyright 1998 by Vadim Kolontsov			
 * All rights reserved
 *
 * Distribute freely, except: don't remove my name from the source or
 * documentation (don't take credit for my work), mark your changes (don't
 * get me blamed for your possible bugs), don't alter or remove this
 * notice.  May be sold if buildable source is provided to buyer.  No
 * warrantee of any kind, express or implied, is included with this
 * software; use at your own risk, responsibility for damages (if any) to
 * anyone resulting from the use of this software rests entirely with the
 * user.
 *
 * Send bug reports, bug fixes, enhancements, requests, flames, etc., and
 * I'll try to keep a version up to date.  I can be reached as follows:
 *
 * Vadim Kolontsov <sb@123.org>
 */

#include <stdio.h>
#include <pcap.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <net/if.h>
#include <net/if_arp.h>
#include <netinet/if_ether.h>

#include "ip.h"

/* Null analyzers */
void ether_analyzer(u_char *usr, const struct pcap_pkthdr *hdr, const u_char *p)
{
	struct ether_header *ep = (struct ether_header *)p;

	if (ntohs(ep->ether_type) == ETHERTYPE_IP)
	  ip_analyze((struct ip *)(p+sizeof(struct ether_header)),
	           (int)(hdr->len-sizeof(struct ether_header)));
}
